package devmanuals.com;

import java.util.concurrent.BlockingDeque;
import java.util.concurrent.LinkedBlockingDeque;

class A implements Runnable 
{
	String name;

	BlockingDeque<Integer> dq;

	public A(String name, BlockingDeque<Integer> dq) 
	{
		this.name = name;
		this.dq = dq;
	}

	public void run() 
	{

		for (int i = 0; i < 5; i++) 
		{
			try {
				dq.putFirst(i);
				System.out.println(name + " puts " + i);
				Thread.sleep(500);
				} 
			catch (InterruptedException e) 
			{
				e.printStackTrace();
			}
		}

	}
}

class B implements Runnable 
{
	String name;

	BlockingDeque<Integer> dq;

	public B(String name, BlockingDeque<Integer> dq) 
	{
		this.name = name;
		this.dq = dq;
	}

	public void run() {
		for (int i = 0; i < 5; i++) 
		{
			try {
				int j = dq.takeLast();
				System.out.println(name + " takes " + j);
				Thread.sleep(1000);
				}
			catch (InterruptedException e) 
			{
				e.printStackTrace();
			}
		}
	}
}

public class BlockingDequeDemo {
	public static void main(String[] args) {
		BlockingDeque<Integer> dq = new LinkedBlockingDeque<Integer>(5);
		Runnable a = new A("A", dq);
		Runnable b = new B("B", dq);
		new Thread(a).start();
		try {
			Thread.sleep(300);
			} 
		catch (InterruptedException e) 
		{
			e.printStackTrace();
		}
		new Thread(b).start();
	}
}